
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Scala 常用语法 / iVAN</title>

    <meta name="description" content="Scala 常用语法 Clojure首先是FP, 但是由于基于JVM, 所以不得已需要做出一些妥协, 包含一些OO的编程方式  Scala首先是OO, Java语法过于冗余, 一种比较平庸的语言, Scala首先做的是简化, 以更为简洁的方式来编写OO, 主要利用'type inference'能推断出来的, 你就不用写, 但如果仅仅这样, 不如用python  所以Scala象其名字一样, &quot;可伸展的语言&quot;, 它是个大的集市, 它积极吸纳其他语言的优秀的特征, 最重要的就是FP, 你可以使用Sc ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Scala 常用语法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Clojure首先是FP, 但是由于基于JVM, 所以不得已需要做出一些妥协, 包含一些OO的编程方式 <br />
Scala首先是OO, Java语法过于冗余, 一种比较平庸的语言, Scala首先做的是简化, 以更为简洁的方式来编写OO, 主要利用‘type inference’能推断出来的, 你就不用写, 但如果仅仅这样, 不如用python <br />
所以Scala象其名字一样, “可伸展的语言”, 它是个大的集市, 它积极吸纳其他语言的优秀的特征, 最重要的就是FP, 你可以使用Scala来写OO, 但它推荐使用FP的方式来写Scala; 还包括Erlang里面的actor模型 <br />
所以Scala并不容易学, 因为比较繁杂</p>
<p>我主要对Scala programing做个笔记, 下面这个哥们整理的更好</p>
<p><a href="http://qiujj.com/static/Scala-Handbook.htm" rel="external nofollow noreferrer">http://qiujj.com/static/Scala-Handbook.htm</a></p>
<p><a href="http://docs.scala-lang.org/" rel="external nofollow noreferrer">http://docs.scala-lang.org/</a> , Scala官方文档</p>
<p><a href="http://www.scala-lang.org/api/current/#package" rel="external nofollow noreferrer">http://www.scala-lang.org/api/current/#package</a>, 参考手册</p>
<p><a href="http://twitter.github.io/effectivescala/index-cn.html" rel="external nofollow noreferrer">http://twitter.github.io/effectivescala/index-cn.html</a>, Effective Scala</p>
<p> </p>
<h2>0</h2>
<h3>Scala interpreter</h3>
<p><pre>scala&gt; 1 + 2
res0: Int = 3

scala&gt; res0 * 3
res1: Int = 9

scala&gt; println("Hello, world!")
Hello, world!</pre>
<p> </p>
<h3>代码段落</h3>
<p>scala中;常常可以省略, 但如果一行有多条语句, 则必须加上</p>
<pre>val s = "hello"; println(s)</pre>
<p>如果一条语句, 要用多行写</p>
<pre>x
+ y</pre>
<p>这样会当作2个语句, 两种方法解决,</p>
<pre>
</pre>
<p>(x<br />
+ y) //加括号</p>
<p>x +<br />
y +<br />
z   //把操作符写在前一行, 暗示这句没完</p>
<p> </p>
<h2>1 基本语法</h2>
<h3>基本类型</h3>
<p><a href="http://images.cnitblog.com/blog/312753/201309/25151826-f50e8cf9cd654d1384e71c5f1d5da275.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDkvMjUxNTE4MzAtNTE3ODg1YzRmMmVmNDAzMDlkZTVhMGY3N2QwMGUwNmUucG5n.jpg"></a></p>
<p>Rich wrappers, 为基本类型提供更多的操作</p>
<p><a href="http://images.cnitblog.com/blog/312753/201309/25151830-0be0754677bd4cb2859eef6bd86137ac.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDkvMjUxNTE4MzAtODk1NmUyZDRhZTdiNGVlZWEyMTkyNTdiZWE0NzgwMjQucG5n.jpg"></a></p>
<p> </p>
<h3>变量定义</h3>
<p><strong>val</strong>, 不可变变量, 常量, 适用于FP <br /><strong>var</strong>, 可变变量, 适用于OO</p>
<pre>scala&gt; val msg = "Hello, world!"
msg: java.lang.String = Hello, world!
scala&gt; msg = "Goodbye cruel world!"
&lt;console&gt;:5: error: reassignment to val msg = "Goodbye cruel world!"</pre>
<p> </p>
<h3>函数定义</h3>
<p><a href="http://images.cnitblog.com/blog/312753/201309/25151831-b21d66f0323b46c4a5a2bf8104df8807.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDkvMjUxNTE4MzEtMmU2NTIyMDY2YzYxNDQ5YmE2YjBlMTU3ZjljNzk5MzcucG5n.jpg"></a></p>
<p>可以简写为, 返回值类型不需要写, 可以推断出, 只有一条语句, 所以{}可以省略</p>
<pre>scala&gt; def max2(x: Int, y: Int) = if (x &gt; y) x else y
max2: (Int,Int)Int</pre>
<p>简单的funciton, 返回值为Unit, 类似Void(区别在于void为无返回值, 而scala都有返回值, 只是返回的为Unit, ())</p>
<pre>scala&gt; def greet() = println("Hello, world!")
greet: ()Unit</pre>

<pre>
</pre>
<p>scala&gt; greet() == ()<br />
Boolean = true</p>
<blockquote><p><strong>函数参数不可变</strong></p>
<pre>def add(b: Byte): Unit = {
  b = 1 // This won’t compile, because b is a val
  sum += b
}</pre>
</blockquote>
<p>重复参数, 最后的*表示可变参数列表, 可传入多个string</p>
<pre>scala&gt; def echo(args: String*) = for (arg &lt;- args) println(arg)</pre>
<pre>
</pre>
<p>scala&gt; echo("hello", "world!")<br />
hello<br />
world!</p>
<p> </p>
<h3>Function literal</h3>
<p>如何翻译... <br />
Scala FP的基础, function作为first class, 以function literal的形式作为参数被传递</p>
<p><a href="http://images.cnitblog.com/blog/312753/201309/25151832-507261b2dfef46418f8a1847aee74119.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDkvMjUxNTE4MzItODczNjYyYmFlNjRjNGRlMWFkYmNjOGMzNDUwZDA0MWIucG5n.jpg"></a></p>
<pre>
</pre>
<p><pre>args.foreach((arg: String) =&gt; println(arg))
args.foreach(arg =&gt; println(arg)) //省略类型
args.foreach(println) //其实连参赛列表也可以省略</pre>
<p>可以看到scala在省略代码量上可以说下足功夫, 只要能推断出来的你都可以不写, 这也是对于静态类型系统的一种形式的弥补</p>
<p>对于oo程序员, 可能比较难理解, 其实等于</p>
<pre>for (arg &lt;args)
  println(arg)</pre>
<p> </p>
<h3>控制结构</h3>
<p>由于scala是偏向于FP的, 所以所有控制结构都有返回值, 这样便于FP编程</p>
<p><strong>If</strong>, 可以返回值</p>
<pre>val filename =
  if (!args.isEmpty) args(0)
  else "default.txt"</pre>
<p><strong></strong> </p>
<p><strong>While</strong>, 在FP里面不推荐使用循环, 应该用递归,尽量避免</p>
<p><strong></strong> </p>
<p><strong>For</strong>, 没有python和clojure的好用或简洁</p>
<pre>for (
  file &lt;- filesHere //generator,用于遍历,每次file都会被从新初始化
  if file.isFile;  //过滤条件, 多个间需要用;
  if file.getName.endsWith(".scala"); //第二个过滤
  line &lt;- fileLines(file)  //嵌套for
  trimmed = line.trim  //Mid-stream variable bindings, val类型,类似clojure let
  if trimmed.matches(pattern)
) println(file +": "+ trimmed)</pre>
<p><pre>//for默认不会产生新的集合, 必须使用yield
def scalaFiles =
  for {
    file &lt;- filesHere
    if file.getName.endsWith(".scala")
  } yield file //yield产生新的集合,类似python</pre>
<p><strong></strong> </p>
<p><strong>match</strong>, switch-case</p>
<p>可以返回值, FP风格, 这样只需要最后println一次 <br />
默认会break, 不需要每次自己加</p>
<pre>val firstArg = if (!args.isEmpty) args(0) else ""
val friend =
  firstArg match {
    case "salt" =&gt; "pepper"
    case "chips" =&gt; "salsa"
    case "eggs" =&gt; "bacon"
    case _ =&gt; "huh?"    //default
}
println(friend)</pre>
<p> </p>
<h3><strong>Option and Either</strong></h3>
<p>参考, <a href="http://www.ibm.com/developerworks/cn/java/j-ft13/index.html" rel="external nofollow noreferrer">http://www.ibm.com/developerworks/cn/java/j-ft13/index.html</a></p>
<p>Option和Either都是用来让返回值可以有两个选择 <br />
而Option是比较简单的版本, 两个选择, 一定是成功Some, 和失败None  <br />
Option意味着可能有值some(x), 也可能没有值(用None对象, 表示缺失), 典型的例子就是从字典里取值</p>
<pre>val capitals = Map("France" -&gt; "Paris", "Japan" -&gt; "Tokyo")
def show(x: Option[String]) = x match { //Option类型, 可选的String
    case Some(s) =&gt; s
    case None =&gt; "?"
}
scala&gt; show(capitals get "France")
res24: String = Paris
scala&gt; show(capitals get "North Pole")
res25: String = ?</pre>
<p>以前的方式, 比如Java, 通过null来表示没有取到值, 但是有的时候null可能作为合法值出现, 就需要特殊处理, 很麻烦 <br />
而Scala提供option来比较优雅的解决这个问题</p>
<p><strong>Either</strong>, 更为通用一些, 可用自己定义两种选择, 直接看个spark源码中的例子, <br />
对于PutResult中的data, 有可能是ByteBuffer或者Iterator <br />
而使用的时候, 使用Left和Right来选择到底用哪一个</p>
<pre>private[spark] case class PutResult(size: Long, data: Either[Iterator[_], ByteBuffer])</pre>
<pre>PutResult(sizeEstimate, Left(values.iterator))
PutResult(bytes.limit(), Right(bytes.duplicate()))</pre>
<p>这里无论option或either都提高了极好的灵活性, 在Java中如果要返回一个有两种可能性的值就比较不那么优雅了, 参考上面的链接</p>
<h3>Implicit Conversions, 隐式转换</h3>
<p>Scala支持这种隐式转换,</p>
<pre>implicit def intToString(x: Int) = x.toString //定义转换函数后, 编译器会自动做转换</pre>
<p>比如x op y无法通过类型检查, int x 不支持op操作, 而string支持, 编译器就会自动调用上面的转换函数, 将int x转化为string x</p>
<p><strong>隐式参数</strong></p>
<p>用法也比较诡异, 看例子</p>
<pre>object Greeter {
    def greet(name: String)(implicit prompt: PreferredPrompt) {//声明2个参数, 第二个是可以隐式的,当然你也可以显式的写
        println("Welcome, "+ name +". The system is ready.")
        println(prompt.preference)
    }
}

object JoesPrefs {
    implicit val prompt = new PreferredPrompt("Yes, master&gt; ") //声明成implicit, 可用作补充
}

import JoesPrefs._
scala&gt; Greeter.greet("Joe") //编译器会自动补充成, greet("Joe")(prompt)
Welcome, Joe. The system is ready.
Yes, master&gt;</pre>
<p> </p>
<p> </p>
<h2>2 数据结构</h2>
<h3>数组</h3>
<pre>可变的同类对象序列, 适用于OO场景</pre>
<pre>val greetStrings = new Array[String](3) //greetStrings为val, 但是内部的数组值是可变的
greetStrings(0) = "Hello"  //scala用()而非[]
greetStrings(1) = ", "
greetStrings(2) = "world!\n"</pre>
<pre>for (i &lt;- 0 to 2)
print(greetStrings(i))</pre>
<pre> </pre>
<pre></pre>
<blockquote><p><strong>Scala 操作符等价于方法, 所以任意方法都可以以操作符的形式使用</strong></p>
<p>1 + 2 //(1).+(2), 在只有一个参数的情况下, 可以省略.和()</p>
<p>0 to 2 //(0).to(2)</p>
<p>greetStrings(0) //greetStrings.apply(0),这也是为什么scala使用(), 而非[]</p>
<p>greetStrings(0) = "Hello" //greetStrings.update(0, "Hello")</p></blockquote>
<pre>简化的array初始化</pre>
<pre>val numNames = Array("zero", "one", "two")  //Array.apply("zero", "one", "two")</pre>
<h3>List</h3>
<p>相对于array, List为不可变对象序列, 适用于FP场景</p>
<pre>
</pre>
<p>val oneTwo = List(1, 2)<br />
val threeFour = List(3, 4)</p>
<p>val zeroOneTwo = 0 :: oneTwo  //::<br />
val oneTwoThreeFour = oneTwo ::: threeFour</p>
<p>对于List最常用的操作符为::, cons, 把新的elem放到list最前端 <br />
:::, 两个list的合并</p>
<blockquote><p><strong>右操作数, ::</strong></p>
<p>普通情况下, 都是左操作数, 比如, a * b  =&gt; a.*(b) <br />
但是当方法名为:结尾时, 为右操作数 <br />
1 :: twoThree  =&gt; twoThree.::(1)</p></blockquote>
<blockquote><p><strong>不支持append <br /></strong>原因是, 这个操作的耗时会随着list的长度变长而线性增长, 所以不支持, 只支持前端cons, 实在需要append可以考虑ListBuffer</p></blockquote>
<p><u>支持模式</u></p>
<pre>scala&gt; val List(a, b, c) = fruit
a: String = apples
b: String = oranges
c: String = pears
scala&gt; val a :: b :: rest = fruit
a: String = apples
b: String = oranges
rest: List[String] = List(pears)</pre>
<p><u>list zip,啮合</u></p>
<pre>scala&gt; abcde.indices zip abcde  //indices返回所有有效索引值
res14: List[(Int, Char)] = List((0,a), (1,b), (2,c), (3,d),(4,e))
scala&gt; val zipped = abcde zip List(1, 2, 3)
zipped: List[(Char, Int)] = List((a,1), (b,2), (c,3)) //会自动截断</pre>
<p><u>Folding lists: /: and :\</u></p>
<p>折叠操作, 比较奇怪的操作, 看例子</p>
<pre>(z /: List(a, b, c)) (op) equals op(op(op(z, a), b), c)
scala&gt; def sum(xs: List[Int]): Int = (0 /: xs) (_ + _) //实现列表元素叠加
(List(a, b, c) :\ z) (op) equals op(a, op(b, op(c, z)))
def flattenLeft[T](xss: List[List[T]]) = (List[T]() /: xss) (_ ::: _) //两种的区别
def flattenRight[T](xss: List[List[T]]) = (xss :\ List[T]()) (_ ::: _)</pre>
<p> </p>
<p><a href="http://images.cnitblog.com/blog/312753/201309/25151833-f6af5380379842f6b6639c424c468d63.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDkvMjUxNTE4MzQtNDU4ZjBhMjk0NDVlNDM5OWFlYWY4OTdlMGRhZTg2ZjUucG5n.jpg"></a> <a href="http://images.cnitblog.com/blog/312753/201309/25151836-455ff806d0cb40a8a3120e74edbf5559.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDkvMjUxNTE4MzgtOTVmOTlhZDVkNmQ2NDVmZTllOWI5N2ZlNjUzNDM0YmYucG5n.jpg"></a> </p>
<h3>Queues</h3>

<pre>import scala.collection.immutable.Queue //不可变Queueval empty = new Queue[Int]
val has1 = empty.enqueue(1) //添加单个元素
val has123 = has1.enqueue(List(2, 3)) //添加多个元素
val (element, has23) = has123.dequeue //取出头元素,返回两个值, 头元素和剩下的queue
element: Int = 1
has23: scala.collection.immutable.Queue[Int] = Queue(2,3)</pre>
<pre> </pre>
<p><pre>import scala.collection.mutable.Queue //可变Queue
val queue = new Queue[String]
queue += "a"  //添加单个
queue ++= List("b", "c") //添加多个
queue.dequeue //取出头元素, 只返回一个值
res22: String = a
scala&gt; queue
res23: scala.collection.mutable.Queue[String] = Queue(b, c)</pre>
<h3>Stacks</h3>
<p><pre>import scala.collection.mutable.Stack
val stack = new Stack[Int]
stack.push(1)
stack.push(2)
scala&gt; stack.top
res8: Int = 2
scala&gt; stack.pop
res10: Int = 2
scala&gt; stack
res11: scala.collection.mutable.Stack[Int] = Stack(1)</pre>

<h3>Tuple</h3>
<p>tuple和list一样是不可变的, 不同是, list中的elem必须是同一种类型, 但tuple中可以包含不同类型的elem</p>
<pre></pre>
<pre>val pair = (99, "Luftballons") //自动推断出类型为,Tuple2[Int, String]
println(pair._1)  //从1开始,而不是0,依照Haskell and ML的传统
println(pair._2) //elem访问方式不同于list, 由于元组中elem类型不同</pre>
<p> </p>
<h3>Set和Map</h3>

<pre>
</pre>
<p>var jetSet = Set("Boeing", "Airbus")<br />
jetSet += "Lear"<br />
println(jetSet.contains("Cessna"))</p>
<pre>val treasureMap = Map[Int, String]()
treasureMap += (1 -&gt; "Go to island.")
treasureMap += (2 -&gt; "Find big X on ground.")
println(treasureMap(2))</pre>
<pre>val romanNumeral = Map(1 -&gt; "I", 2 -&gt; "II", 3 -&gt; "III" ) //简写</pre>
<p> </p>
<p>Scala需要兼顾OO和FP, 所以需要提供mutable和immutable版本 <br />
这里默认是Immutable, 如果需要使用mutable版本, 需要在使用前显示的引用...</p>
<pre>import scala.collection.mutable.Set
import scala.collection.mutable.Map</pre>
<p> <a href="http://images.cnitblog.com/blog/312753/201311/08152813-34490330ae4c4ae5b9ba18e0159a6ba6.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMTEvMDgxNTI4MTQtZjJmODRjMmI2NmMzNDY0NDlmM2M4MmUxZjZhMzRlZjcucG5n.jpg"></a> <a href="http://images.cnitblog.com/blog/312753/201311/08152814-a1fc80a7ffb44d508e754500c94c7e6d.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMTEvMDgxNTI4MTQtNGI1ZmRkNmYzMDk0NDhiMzhhZmUzNDk5MGY4ZDIzZWUucG5n.jpg"></a></p>
<p><strong>Sorted Set and Map</strong></p>
<p>和Java一样, Scala也提供基于红黑树实现的有序的Set和Map</p>
<pre>import scala.collection.immutable.TreeSet
scala&gt; val ts = TreeSet(9, 3, 1, 8, 0, 2, 7, 4, 6, 5)
ts: scala.collection.immutable.SortedSet[Int] =
Set(0, 1, 2, 3, 4, 5, 6, 7, 8, 9)
scala&gt; val cs = TreeSet('f', 'u', 'n')
cs: scala.collection.immutable.SortedSet[Char] = Set(f, n, u)

import scala.collection.immutable.TreeMap
scala&gt; var tm = TreeMap(3 -&gt;'x', 1 -&gt;'x', 4 -&gt;'x')
scala&gt; tm += (2 -&gt;'x')
scala&gt; tm
res38: scala.collection.immutable.SortedMap[Int,Char] = Map(1 -&gt;x, 2 -&gt;x, 3 -&gt;x, 4 -&gt;x)</pre>
<p> </p>
<h2>3 面向对象-OO</h2>
<h3>类和对象</h3>
<p>相对于Java定义比较简单, 默认public</p>
<pre>
</pre>
<p>class ChecksumAccumulator {<br />
  private var sum = 0<br />
  def add(b: Byte): Unit = {<br />
    sum += b<br />
  } </p>
<p>def checksum(): Int = {<br />
    return ~(sum &amp; 0xFF) + 1<br />
  }<br />
}</p>
<p>进一步简化, 去掉{}和return, 默认将最后一次计算的值返回 <br />
不写return是推荐的方式, 因为函数尽量不要有多个出口 </p>
<pre>
</pre>
<p>class ChecksumAccumulator {<br />
  private var sum = 0<br />
  def add(b: Byte): Unit = sum += b<br />
  def checksum(): Int = ~(sum &amp; 0xFF) + 1<br />
}</p>
<p>其实对于Unit(void), 即没有返回值, 对于FP而言, 就是该function只会产生side effect, 还有另外一种简写的方式 </p>
<pre>
</pre>
<p>class ChecksumAccumulator {<br />
  private var sum = 0<br />
  def add(b: Byte) { sum += b } //对于Unit返回的, 另一种简写, 用{}来表示无返回, 所以前面的就不用写了<br />
  def checksum(): Int = ~(sum &amp; 0xFF) + 1<br />
}</p>
<p>实例化</p>
<pre>
</pre>
<p>val acc = new ChecksumAccumulator<br />
val csa = new ChecksumAccumulator<br />
acc.sum = 3</p>
<p><a href="http://images.cnitblog.com/blog/312753/201309/25151839-626cb5656da9424fb2c1b49ecd7b4db2.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDkvMjUxNTE4MzktNTM3MGQ4ODQwZWIxNGYzN2FjNTA3ODQ2ZmM5Y2E2MmQucG5n.jpg"></a> <a href="http://images.cnitblog.com/blog/312753/201309/25151840-f4efb042ab3045bbb757ac8c9edc17d6.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDkvMjUxNTE4NDAtYjU1ZTU4ZDc5NzhhNDE3NmE2ZmRjMTQxOWU0YTNiNzEucG5n.jpg"></a> </p>
<p><strong>Singleton对象</strong></p>
<p>Scala不能定义静态成员, 所以用Singleton对象来达到同样的目的</p>
<pre>import scala.collection.mutable.Map
object ChecksumAccumulator {       //用object代替class
  private val cache = Map[String, Int]()
  def calculate(s: String): Int =
    if (cache.contains(s))
      cache(s)
    else {
      val acc = new ChecksumAccumulator
      for (c &lt;s)
        acc.add(c.toByte)
      val cs = acc.checksum()
      cache += (s -&gt; cs)
      cs
    }
}</pre>
<p><a href="http://images.cnitblog.com/blog/312753/201309/25151840-02c7b7c4cd7a411f98cc0d5463d10bca.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMDkvMjUxNTE4NDEtMWQ1YzMzNDNjZTAwNGRhMjhiNmY1NWFiOTNkYWRmMmQucG5n.jpg"></a> </p>
<p>最常见的场景就是, 作为scala程序的入口,</p>
<p>To run a Scala program, you must supply the name of a<strong> standalone singleton</strong> object with a <strong>main method</strong> that takes <strong>one parameter(Array[String])</strong>, and has a <strong>result type of Unit</strong>.</p>
<pre>import ChecksumAccumulator.calculate
  object Summer {
    def main(args: Array[String]) {
      for (arg &lt;args)
        println(arg +": "+ calculate(arg))
    }
}</pre>
<p><strong>不可变对象</strong></p>
<p>适用于FP场景的对象, 所以也叫做Functional Objects. <br />
好处, 消除可变带来的复杂性, 可以放心的当参数传递, 多线程下使用啊...</p>
<p>下面以定义有理数类为例</p>
<pre>class Rational(n: Int, d: Int)  //极简方式,没有类主体</pre>
<p>和上面的定义比, 不需定义成员变量, 而只是通过参数, 因为根本没有定义成员变量, 所以无处可变.</p>
<pre>class Rational(n: Int, d: Int) {
  require(d != 0)    //Precondition, 如果require返回false会抛出IllegalArgumentException,阻止初始化
  private val g = gcd(n.abs, d.abs)
  val numer = n / g  //添加不可变成员字段,便于引用
  val denom = d / g

  def this(n: Int) = this(n, 1) //辅助构造函数

  def + (that: Rational): Rational =  //定义操作符
    new Rational(
      numer * that.denom + that.numer * denom, denom * that.denom //也可以使用this.number引用成员
    )
  def + (i: Int): Rational =    //典型的成员函数重载
    new Rational(numer + i * denom, denom)

  override def toString = numer +"/"+ denom //override, 方法重载

  private def gcd(a: Int, b: Int): Int = if (b == 0) a else gcd(b, a % b)
}</pre>
<p><strong>可变对象</strong></p>
<p>可变Objects本身没啥好说的, 说说Scala getter和setter规则</p>
<p>every <strong>var</strong> that is a non-private member of some object implicitly defines a getter and a setter method with it. <br />
The <strong>getter</strong> of a var x is just named “x”, while its <strong>setter</strong> is named “x_=”.</p>
<p>每个非私有的var都会隐含的自动定义getter和setter, 如下面的例子</p>
<pre>class Time {
    var hour = 12
    var minute = 0
}
//等同于
class Time {
    private[this] var h = 12
    private[this] var m = 0
    def hour: Int = h
    def hour_=(x: Int) { h = x }
    def minute: Int = m
    def minute_=(x: Int) { m = x }
}</pre>
<p>所以在Scala中比较有趣的是, 其实你可以不真正定义这个成员, 而只需要定义getter和setter就可以 <br />
如下面的例子, 并没有真正定义华氏温度, 而只是定义了getter和setter, 更简洁</p>
<pre>class Thermometer {
    var celsius: Float = _
    def fahrenheit = celsius * 9 / 5 + 32
    def fahrenheit_= (f: Float) {
        celsius = (f 32)
        * 5 / 9
    }
    override def toString = fahrenheit +"F/"+ celsius +"C"
}</pre>
<p> </p>
<h3>组合和继承</h3>
<p><strong>抽象类</strong></p>
<pre>abstract class Element {  //abstract表示抽象类
    def contents: Array[String]  //没有函数体表示声明抽象方法
}</pre>
<p><strong>无参函数和属性, 统一访问模式</strong></p>
<p>客户可以用同样的方式来访问函数width或属性width, 这样的好处是width改变不同的实现方式时, 不会影响客户代码, 实现统一访问模式</p>
<p>函数和属性的区别, 函数节省空间而需要每次计算, 属性是初始化时算好的, 比较快, 但需要额外的空间, 所以可用在不同场景下选择不同实现</p>
<pre>abstract class Element {
   def contents: Array[String]  //组合Array[]
   def height: Int = contents.length //无参函数
   def width: Int = if (height == 0) 0 else contents(0).length
}
//等同于
abstract class Element {
    def contents: Array[String]
    val height = contents.length //属性
    val width = if (height == 0) 0 else contents(0).length
}</pre>
<p>Scala为了实现这种统一的访问模式, 一般对于无参函数在调用时可以省掉(), 但前提是该无参函数是没有副作用的, 否则就会比较confusing</p>
<pre>"hello".length // no () because no sideeffect
println() // better to not drop the (),因为有副作用</pre>
<p><strong>继承</strong></p>
<p>超类的私有成员不会被子类继承. <br />
抽象成员, 需要被子类实现(implement) <br />
一般成员, 可用被子类重写(override)</p>
<blockquote><p><strong>override</strong>关键字的使用, <br />
重写时, 必须显式加override, 防止意外的重写 <br />
实现时, 是否写override可选 <br />
其他情况禁止使用</p></blockquote>
<pre>class ArrayElement(conts: Array[String]) extends Element {
    def contents: Array[String] = conts  //实现抽象函数
}</pre>
<p>这个图, 反映出继承和组合, 其中Element继承自AnyRef, 而ArrayElement组合Array[]</p>
<p><a href="http://images.cnitblog.com/blog/312753/201310/26171345-7f21d787946d4c1aa75aa6ecdfc591cf.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMTAvMjYxNzEzNDYtMjM2MTViZDliMjY5NGE2NWI4MzdjNzM5ZDQyZWM2ZDIucG5n.jpg"></a></p>
<p><strong>重写方法和属性</strong></p>
<p>这是scala比较特别的地方, 方法和属性在同一个命名空间, 所以方法和属性不能同名 <br />
并且支持, 在override时, 方法和属性间可用互相转换</p>
<p>前面将contents声明成方法, 是否觉得有些别扭, 看上去更像属性, 是的, 你可用在子类中实现或重写成属性 <br />
在scala中, 无副作用的无参函数和属性是可以简单的互相转换</p>
<pre>class ArrayElement(conts: Array[String]) extends Element {
    val contents: Array[String] = conts //将方法contents实现成属性
}</pre>
<p>Java和Scala的命名空间对比</p>
<blockquote><p>Java’s four namespaces are <strong>fields</strong>, <strong>methods</strong>, <strong>types</strong>, and <strong>packages</strong>. <br />
By contrast, Scala’s two namespaces are: <br />
• <strong>values</strong> (fields, methods, packages, and singleton objects) <br />
• <strong>types</strong> (class and trait names)</p></blockquote>
<p><strong>参数化属性</strong></p>
<p>一种scala的简化, <br />
是否觉得, 定义参数, 再将参数赋值给属性, 很麻烦, ok, scala可用简化</p>
<pre>class ArrayElement( val contents: Array[String] ) extends Element //实现属性</pre>
<p>另一个例子,</p>
<pre>class Cat {
    val dangerous = false
}
class Tiger(
    override val dangerous: Boolean, //重写属性
    private var age: Int  //增加新的属性
) extends Cat</pre>
<p><strong>超类构造器</strong></p>
<p>和C++或Pythno一样, 需要在子类中显式的构造超类, 比如这里需要先构造ArrayElement <br />
只不过Scala提供一种简写的方式, 而不用在代码中另写一行</p>
<pre>class LineElement(s: String) extends ArrayElement(Array(s)) {
    override def width = s.length
    override def height = 1
}</pre>
<p><strong>final成员</strong></p>
<pre>class ArrayElement extends Element {
    final override def demo() { //该成员函数禁止被任何子类override
        println("ArrayElement's implementation invoked")
    }
}
final class ArrayElement extends Element {//ArrayElement禁止被任何子类继承
    override def demo() {
        println("ArrayElement's implementation invoked")
    }
}</pre>
<p><strong>工厂对象实现</strong></p>
<pre>object Element { //用伴生对象(Singleton)来做工厂对象
    def elem(contents: Array[String]): Element =
        new ArrayElement(contents)
    def elem(chr: Char, width: Int, height: Int): Element =
        new UniformElement(chr, width, height)
    def elem(line: String): Element =
        new LineElement(line)
}</pre>

<h3>Scala的类层次</h3>
<p>At the top of the hierarchy is class <strong>Any</strong>.</p>
<p>Any声明如下接口, 故所有类都支持这些接口,</p>
<pre>final def ==(that: Any): Boolean
final def !=(that: Any): Boolean
def equals(that: Any): Boolean
def hashCode: Int
def toString: String</pre>
<p>Any有两个子类, AnyVal和AnyRef <br /><strong>AnyVal</strong>是所有built-in value class的父类, 除了常见的基本类型外, 还有Unit <br /><strong>AnyRef</strong>是所有reference classes的父类, 其实就是java.lang.Object</p>
<p>Scala还定义, Nothing和Null class <br />
Nothing是所有Any的子类, 而Null是所有AnyRef的子类 <br />
干吗用的?用于以统一的方式来处理边界形式或异常返回, 因为他们是所有类的子类, 所有可用返回给任意返回类型</p>
<p>例子,</p>
<pre>def error(message: String): Nothing =
    throw new RuntimeException(message)
def divide(x: Int, y: Int): Int = //返回类型为Int
    if (y != 0) x / y
    else error("can't divide by zero") //异常时返回Nothing</pre>
<p><a href="http://images.cnitblog.com/blog/312753/201310/26171346-3ecc136609a04093ac57a7f5b10cc886.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzMxMjc1My8yMDEzMTAvMjYxNzEzNDYtNDg1NDE3ZWY0NDcyNGE2MDhlOTBhODM1NjkxODk5ZjAucG5n.jpg"></a></p>
<p> </p>
<h3><strong>Package管理</strong></h3>
<p>支持package嵌套和通过{}指定范围</p>
<pre>package launch {
    class Booster3
}
package bobsrockets {
    package navigation {
        class Navigator
    }
    package launch {
        class Booster {
            // No need to say bobsrockets.navigation.Navigator
            val nav = new navigation.Navigator
            val booster3 = new _root_.launch.Booster3 //_root_特指顶层包
        }
    }
}</pre>
<p><strong>Import的用法</strong></p>
<pre>import bobsdelights.Fruit
import bobsdelights._  //import all

import Fruits.{Apple, Orange} //指定import
import Fruits.{Apple =&gt; McIntosh, Orange} //别名
import Fruits.{Apple =&gt; _, _} //排除Apple</pre>

<h3><strong>访问修饰符</strong></h3>
<p><strong>Private</strong></p>
<p>基本和Java一致，但是在对inner class上表现出更好的一致性 <br />
Java允许外部类访问内部类的private成员，而scala不行，如下例子中的error case</p>
<pre>class Outer {
    class Inner {
        private def f() { println("f") }
        class InnerMost {
            f() // OK
        }
    }
    (new Inner).f() // error: f is not accessible
}</pre>
<p><strong>Protected</strong></p>
<p>同样比Java更严格一些，仅允许在子类中被访问 <br />
而Java允许同一个包中的其他类访问该类的protected成员，而scala中不行，如下面的error case</p>
<pre>package p {
    class Super {
        protected def f() { println("f") }
    }
    class Sub extends Super {
        f()
    }
    class Other {
        (new Super).f() // error: f is not accessible
    }
}</pre>
<p><strong>修饰符作用域</strong></p>
<p>scala中的修饰符可以加上作用域，非常灵活 <br />
private[X] or protected[X] means that access is private or protected “up to” X, where X designates some enclosing package, class or singleton object. <br />
加上作用域的意思，除了原来private和protect表示的可见范围外，将可见范围扩展到X，X可以是package，class，singleton对象</p>
<pre>package bobsrockets {
    package navigation {
        private[bobsrockets] class Navigator { //使Navigator类在bobsrockets package中可见，所以在package launch中可以new Navigator
            protected[navigation] def useStarChart() {} //在Navigator和子类，以及package Navigation中可以被访问(等同于Java)
            class LegOfJourney {
                private[Navigator] val distance = 100 //是私有变量distance，在外部类Navigtor中可见(等同于Java)
            }
            private[this] var speed = 200 //仅仅在相同对象中可以访问，比private的相同类访问还严格，如下例
             val other = new Navigator
            other.speed // this line would not compile
        }
    }
    package launch {
        import navigation._
        object Vehicle {
            private[launch] val guide = new Navigator
        }
    }
}</pre>
<p><strong>伴生对象 <br /></strong>A class<strong> shares all</strong> its access rights with its companion object and vice versa.</p>
<p> </p>
<p><strong></strong></p>
<h3>Trait</h3>
<p>概念上类似Java的interface, 但是更强大, 可以有方法实现, 属性... <br />
其实几乎等同于class, 除了两点, <br /><u>a. trait不能有任何参数 <br />
b. trait中super是动态绑定的, 因为定义的时候根本就不知道super是谁</u></p>
<pre>trait Philosophical {
    def philosophize() {
        println("I consume memory, therefore I am!")
    }
}</pre>
<p>mix in有两种方式, extend和with <br /><strong>extend</strong>, implicitly inherit the trait’s superclass <br />
所以下面的例子, Frog会继承Philosophical的超类AnyRef</p>
<pre>class Frog extends Philosophical { //mix in Philosophical trait
    override def toString = "green"
}</pre>
<p><strong>with</strong>, 需要显式的指明超类</p>
<pre>class Animal
trait HasLegs
class Frog extends Animal with Philosophical with HasLegs {//继承Animal,并mix in两个traits
    override def toString = "green"
}</pre>
<p>Trait真正的作用在于, 模块封装, 可以把相对独立的功能封装在trait中, 并在需要的时候进行mix in, 如下面的例子</p>
<pre>//传统的例子
class Rational(n: Int, d: Int) {
     // ...
     def &lt; (that: Rational) =
     this.numer * that.denom &gt; that.numer * this.denom
     def &gt; (that: Rational) = that &lt; this
     def &lt;= (that: Rational) = (this &lt; that) || (this == that)
     def &gt;= (that: Rational) = (this &gt; that) || (this == that)
 }

//将比较接口和实现封装在Ordered Trait中,这里仅仅需要mix in和实现compare
class Rational(n: Int, d: Int) extends Ordered[Rational] {
     // ...
     def compare(that: Rational) =
     (this.numer * that.denom) (
     that.numer * this.denom)
 }</pre>
<p><strong>Traits as stackable modifications</strong></p>
<p>trait的强大还体现在可以同时mix in多个traits, 并以类似stackable形式的线性调用, 即多个trait会效果叠加 <br />
而传统的多重继承, 只有一个实现会有效</p>
<pre>abstract class IntQueue {
    def get(): Int
    def put(x: Int)
}
import scala.collection.mutable.ArrayBuffer
class BasicIntQueue extends IntQueue {
    private val buf = new ArrayBuffer[Int]
    def get() = buf.remove(0)
    def put(x: Int) { buf += x }
}

trait Doubling extends IntQueue { //trait继承自IntQueue, 说明该trait只能mix in IntQueue(或子类)中
//注意这里super的使用(动态绑定), 和abstract override(仅用于这种场景)
//表示trait must be mixed into some class that has a concrete definition of the method in question
    abstract override def put(x: Int) { super.put(2 * x) }
}

trait Incrementing extends IntQueue {
    abstract override def put(x: Int) { super.put(x + 1) }
}

trait Filtering extends IntQueue {
    abstract override def put(x: Int) {
        if (x &gt;= 0) super.put(x)
    }
}</pre>
<p>下面来看看, 怎么样进行stackable的调用</p>
<pre>//同时mix in了Incrementing和Filtering
//注意调用顺序是, 从右到左(stackable)
//这个例子, 先调用Filtering, 再调用Incrementing, 顺序不同会带来不同的结果
scala&gt; val queue = (new BasicIntQueue with Incrementing with Filtering)
queue: BasicIntQueue with Incrementing with Filtering...
scala&gt; queue.put(-1); queue.put(0); queue.put(1)
scala&gt; queue.get()
res15: Int = 1
scala&gt; queue.get()
res16: Int = 2</pre>
<p><strong>To trait, or not to trait</strong></p>
<p>If the behavior will not be reused, then make it a concrete class.</p>
<p>If it might be reused in multiple, unrelated classes, make it a trait.</p>
<p>If you want to inherit from it in Java code, use an abstract class.</p>
<p>If you plan to distribute it in compiled form, and you expect outside groups to write classes inheriting from it, you might lean towards using an abstract class.</p>
<p>If efficiency is very important, lean towards using a class.</p>
<p> </p>
<h2>4 函数编程-FP</h2>
<h3>函数和闭包</h3>
<p><strong>成员函数</strong>, OO的方式</p>
<p><strong>内部函数</strong>, 需要切分功能, 又不想污染外部的命名空间</p>
<p><strong>First-class function</strong>, unnamed function literal <br />
function象变量一样, 可以被赋值和当参数传递, 但在scala需要以function literal的形式, 在运行期的时候会实例化为函数值(function value)</p>
<pre>scala&gt; var increase = (x: Int) =&gt; x + 1
scala&gt; increase(10)</pre>
<p><strong>Partially applied functions</strong></p>
<pre>scala&gt; def sum(a: Int, b: Int, c: Int) = a + b + c
scala&gt; val a = sum _  //用占位符代替整个参数列表
scala&gt; a(1, 2, 3)  //a.apply(1, 2, 3)
res13: Int = 6

scala&gt; val b = sum(1, _: Int, 3) //partial function, 用占位符代替一个参数
scala&gt; b(2)
res15: Int = 6</pre>
<p><strong>Closures</strong></p>
<p>关于闭包的解释, <br />
对于通常的function, (x: Int) =&gt; x + 1, 称为closed term <br />
而对于(x: Int) =&gt; x + more, 称为open term <br />
所以对于开放的, 必须在定义的时候对里面的自由变量more动态进行绑定, 所以上下文中必须要有对more的定义, 这种关闭open term过程产生了closure</p>
<pre>scala&gt; var more = 1
scala&gt; val addMore = (x: Int) =&gt; x + more  //产生闭包,绑定more
scala&gt; addMore(10)
res19: Int = 11
scala&gt; more = 9999
scala&gt; addMore(10)
res21: Int = 10009  //可见闭包绑定的不是value,而是变量本身</pre>
<p>刚看到有些惊讶, 去clojure里面试一下, 也是这样的, 绑定的变量本身, 闭包会取最新的值 <br />
当然一般不会这样使用闭包.</p>
<p>下面这个例子, 是较常用的case, 其中闭合了函数的参数 <br />
如何在闭包调用时, 可以访问到已经不存在的变量? 当产生闭包时, 编译器会将这个变量从堆栈放到堆里面, 所以函数结束后还能访问</p>
<pre>
</pre>
<p>def makeIncreaser(more: Int) = (x: Int) =&gt; x + more</p>
<p>scala&gt; val inc1 = makeIncreaser(1)<br />
scala&gt; val inc9999 = makeIncreaser(9999)<br />
scala&gt; inc1(10)<br />
res24: Int = 11<br />
scala&gt; inc9999(10)<br />
res25: Int = 10009</p>
<p> </p>
<h3>Currying</h3>
<p>先提供sum的两个版本的比较,</p>
<pre>scala&gt; def plainOldSum(x: Int, y: Int) = x + y
scala&gt; plainOldSum(1, 2)
res4: Int = 3

scala&gt; def curriedSum(x: Int)(y: Int) = x + y  //currying版本的sum
curriedSum: (Int)(Int)Int
scala&gt; curriedSum(1)(2)
res5: Int = 3</pre>
<p>其实currying, 等同于调用两次function, first会返回第二个函数的函数值, 其中closure了x</p>
<pre>scala&gt; def first(x: Int) = (y: Int) =&gt; x + y
first: (Int)(Int) =&gt; Int</pre>
<p>取出函数值, 效果是减少了参数个数, 第一个函数的参数已经closure在第二个函数中了, 和partially有些类似(区别)</p>
<pre>scala&gt; val onePlus = curriedSum(1)_
onePlus: (Int) =&gt; Int = &lt;function&gt;
scala&gt; onePlus(2)
res7: Int = 3</pre>
<p>有什么用? 用于创建更像built-in的控制结构 <br />
如下, 使用{}更像built-in, 但{}有个限制是, 只有单个参数的参数列表可以用{}替换(), 所以这个时候需要用currying来降低参赛个数</p>
<pre>scala&gt; println("Hello, world!")    //象方法调用
scala&gt; println { "Hello, world!" }  //更像built-in的控制结构,比如if</pre>
<p>对于FP, 相对于OO使用继承和多态, 使用函数作为参数来实现代码重用, 希望可以将函数值放在{}, 显得更象built-in <br />
比如下面, 每次打开文件, 操作, 关闭文件, 固定模式, 所以实现withPrintWriter, 每次传入不同的op就可以进行不同的操作, 而不用考虑文件开关 <br />
如果是oo实现, 就需要传入基类对象, 利用多态实现, 明显使用函数更轻量级一些</p>
<pre>def withPrintWriter(file: File, op: PrintWriter =&gt; Unit) {
  val writer = new PrintWriter(file)
  try {
    op(writer)
  } finally {
    writer.close()
  }
}
//以调用方法的方式使用
withPrintWriter(
  new File("date.txt"),
  writer =&gt; writer.println(new java.util.Date)
)</pre>
<p>通过currying减少了参数, 所以就可以使用{}</p>
<pre>def withPrintWriter(file: File)(op: PrintWriter =&gt; Unit) {......} //currying版本
val file = new File("date.txt")
withPrintWriter(file) { writer =&gt; writer.println(new java.util.Date) } //将函数值放在{}, 很像built-in</pre>
<p> </p>
<h3>尾递归,Tail recursion</h3>
<p>前面说了, FP尽量避免使用循环, 而应该使用递归 <br />
但是递归效率有问题, 不停的压栈, 也很容易爆堆栈 <br />
所以对于某种递归, 尾递归, 编译器会自动优化成循环执行, 避免多次使用堆栈 <br />
局限是, 不是什么情况都能写成尾递归, 其实只有循环可以... <br />
比clojuer好, 编译器会自动进行优化</p>
<pre>//while, 循环版本,oo
def approximateLoop(initialGuess: Double): Double = {
  var guess = initialGuess
  while (!isGoodEnough(guess))
    guess = improve(guess)
  guess
}

//递归版本,FP
def approximate(guess: Double): Double =
  if (isGoodEnough(guess)) guess
  else approximate(improve(guess))</pre>
<p> </p>
<h3>Pattern Matching</h3>
<p>pattern matching (模式匹配是FP里面比较高级的特性), 可以参考一下clojure的Multimethods <br />
那么Scala要如何来支持pattern matching?</p>
<p><strong>Case Class</strong></p>
<p>首先case class是用于让你更加简洁的使用pattern matching, 如果你想对一个class进行pattern matching, 最好在前面加上case, 如下面的例子(string和double的一元或二元操作)</p>
<pre>abstract class Expr
case class Var(name: String) extends Expr
case class Number(num: Double) extends Expr
case class UnOp(operator: String, arg: Expr) extends Expr
case class BinOp(operator: String, left: Expr, right: Expr) extends Expr</pre>
<p>那么成为case class, 如何就能便于pattern matching? <br />
1. 添加与类名一样的工厂方法, 即创建类对象时不需要new, 更简洁</p>
<pre>scala&gt; val v = Var("x") //替代new Var("x") </pre>
<pre>scala&gt; val op = BinOp("+", Number(1), v)//new BinOp("+", new Number(1), v) </pre>
<p>2. all arguments in the parameter list of a case class implicitly get a val prefix, so they are maintained as fields. 参数会默认隐含的加上val前缀, 所以可以当作field来用</p>
<pre>scala&gt; v.name
res0: String = x
scala&gt; op.left
res1: Expr = Number(1.0)</pre>
<p>3. the compiler adds “natural” implementations of methods <em>toString</em>,<em> hashCode</em>, and <em>equals</em> to your class. 意味着可以用于println和"=="</p>
<pre>scala&gt; println(op)
BinOp(+,Number(1.0),Var(x))
scala&gt; op.right == Var("x")
res3: Boolean = true</pre>
<p>case class带来的副作用就是你的类会比原来的大一些</p>
<p> </p>
<p><strong>Pattern matching</strong></p>
<p>下面给个例子来说明, 实现方式非常类似switch…case <br />
match关键字表明匹配前面的expr <br />
每个case, case开头, 跟着需要匹配的模式, =&gt;后面加上执行语句 <br />
下面的例子的意思, 简化expr, 当出现两个-号, +0, 或*1的情况下, 就直接返回变量e就可以</p>
<pre>def simplifyTop(expr: Expr): Expr = expr match {
    case UnOp("-", UnOp("-", e)) =&gt; e //UnOp构造器匹配(匹配类型和参数), "-"常量匹配(使用==), e变量匹配(任意值,并方便后面引用)
    case BinOp("+", e, Number(0)) =&gt; e
    case BinOp("*", e, Number(1)) =&gt; e // Multiplying by one
    case _ =&gt; expr  //-通配符匹配, 匹配任意值,但无法引用
}</pre>

<blockquote><p>和switch case的区别 <br />
1. match是scala中的expression, 所以一定会返回值 <br />
2. 不用加break, 匹配即返回 <br />
3. 如果没有匹配上, 会抛MatchError异常, 所以你必须考虑到所有case, 或加上默认case</p></blockquote>
<p><strong>Pattern种类</strong></p>
<p><u>Wildcard patterns, 通配符模式</u></p>
<p>catch all, 用于忽略你不关心的部分</p>
<pre>expr match {
    case BinOp(_, _, _) =&gt; println(expr +"is a binary operation")
    case _ =&gt; println("It's something else")
}</pre>
<p><u>Constant patterns, 常量模式</u></p>
<p>Any <em>literal</em> may be used as a constant. For example, 5, true, and "hello" are all constant patterns. <br />
Also, any <em>val</em> or <em>singleton object</em> can be used as a constant.</p>
<pre>def describe(x: Any) = x match {
    case 5 =&gt; "five"
    case true =&gt; "truth"
    case "hello" =&gt; "hi!"
    case Nil =&gt; "the empty list" //单例对象Nil匹配空列表
    case _ =&gt; "something else"
}</pre>
<p><u>Variable patterns, 变量模式</u></p>
<p>变量模式, 和通配符一样是catch all, 但是区别就在于, 后面可以通过变量引用</p>
<pre>expr match {
    case 0 =&gt; "zero"
    case somethingElse =&gt; "not zero: "+ somethingElse
}</pre>

<blockquote><p>变量模式和常量模式的区别</p>
<pre>scala&gt; import Math.{E, Pi}
import Math.{E, Pi}
scala&gt; E match {
        case Pi =&gt; "strange math? Pi = "+ Pi //Pi是常量而非变量
        case _ =&gt; "OK"
    }
res10: java.lang.String = OK</pre>
<p>所有小写字母开头的为变量模式, 其他的都是常量模式 <br />
如果要用小写字母开头表示变量, 两种方法, 加前缀this.pi, 加反引号`pi`</p></blockquote>
<p><u>Constructor patterns, 构造器模式</u></p>
<p>这个模式使得scala的模式匹配显得格外强大, 因为这样可以deep match <br />
比如下面的例子, 可以匹配BinOP类, 类参数+, e, Number类, Number类的参数0, 可以达到3层的deep match</p>
<pre>expr match {
    case BinOp("+", e, Number(0)) =&gt; println("a deep match")
    case _ =&gt;
}</pre>
<p><u>Sequence patterns, 序列模式</u></p>
<pre>expr match {
    case List(0, _, _) =&gt; println("found it") //第一个为0的length为3的List
    case _ =&gt;
}
expr match {
    case List(0, _*) =&gt; println("found it") //第一个为0,可变长的List
    case _ =&gt;
}</pre>
<p><u>Tuple patterns, 元组模式</u></p>
<p>特别之处在于, 可以用tuple给多个变量赋值</p>
<pre>def tupleDemo(expr: Any) =
expr match {
    case (a, b, c) =&gt; println("matched "+ a + b + c)
    case _ =&gt;
}</pre>
<p><u>Typed patterns, 类型模式</u></p>
<p>需要注意的是, 在类型模式下用s替换x <br />
原因在于, x的类型是Any, 所以你无法调用x.length, 所以必须使用string s来替换x</p>
<pre>def generalSize(x: Any) = x match {
    case s: String =&gt; s.length
    case m: Map[_, _] =&gt; m.size //匹配任意Map
    case _ =&gt; -1
}</pre>
<p>可以看到这里很方便, 如果你对比一下使用传统的isInstanceOf and asInstanceOf的方式</p>
<p><u>Type erasure, 类型擦除</u></p>
<p>可以看到运行时, 编译器是无法check Map中数据的类型的, 因为Scala和Java一样使用了erasure model of generics(泛型的擦除模式), 参数类型信息没有保留到运行期</p>
<pre>scala&gt; def isIntIntMap(x: Any) = x match {
    case m: Map[Int, Int] =&gt; true //会报unchecked warning, 因为无法check Map中是否为Int
    case _ =&gt; false
}
scala&gt; isIntIntMap(Map(1 &gt;1))
res17: Boolean = true
scala&gt; isIntIntMap(Map("abc" &gt;"abc"))
res18: Boolean = true  //可以看出, 其实是无法区分Map中数据类型的</pre>
<p>但是, 数组是唯一的意外, 因为他们被特殊实现, 在运行期会保留参数类型信息, </p>
<pre>scala&gt; def isStringArray(x: Any) = x match {
    case a: Array[String] =&gt; "yes"
    case _ =&gt; "no"
}
scala&gt; val ai = Array(1, 2, 3)
scala&gt; isStringArray(ai)
res20: java.lang.String = no //对于数组可以识别出</pre>
<p><u>Variable binding, 变量绑定</u></p>
<p>通过@将UnOp("abs", _)绑定到变量e上</p>
<pre>expr match {
    case UnOp("abs", e @ UnOp("abs", _)) =&gt; e
    case _ =&gt;
}</pre>
<p><strong>Pattern guards</strong></p>
<p>其实就是在模式后面加上一定的条件判断, 通过了才会执行后面的语句 <br />
比如下面的例子, 判断x是否等于y,</p>
<pre>scala&gt; def simplifyAdd(e: Expr) = e match {
    case BinOp("+", x, y) if x == y =&gt; BinOp("*", x, Number(2)) //加上条件判断, 称为pattern guard
    case _ =&gt; e
}</pre>
<p><strong>Pattern overlaps</strong></p>
<p>Scala支持多个Pattern重叠, 比如下面的例子, 匹配第一个的, 一定也会匹配第二个, 第三个 <br />
但顺序不能反, 必须先具体的, 后general的, 否则编译器会报错</p>
<pre>def simplifyAll(expr: Expr): Expr = expr match {
    case UnOp("-",UnOp("-",e)) =&gt; simplifyAll(e) // ‘-’is its own inverse
    case UnOp(op, e) =&gt; UnOp(op, simplifyAll(e))
    case _ =&gt; expr
}</pre>
<p><strong>Sealed classes</strong></p>
<p>Sealed意味着只能在这个文件定义子类, 这样就不能随便在其他地方增加case类 <br />
这样做的原因是, scala要求模式匹配时需要考虑到所有的情况, 所以程序员都需要知道到底有哪些case class <br />
通过Sealed class, 不但程序员可以在该文件中找到所有的case class, 而且scala编译器也会找到, 并在编译时做检查,</p>
<pre>sealed abstract class Expr  //sealed
case class Var(name: String) extends Expr
case class Number(num: Double) extends Expr
case class UnOp(operator: String, arg: Expr) extends Expr
case class BinOp(operator: String, left: Expr, right: Expr) extends Expr</pre>
<pre> </pre>
<pre>def describe(e: Expr): String = (e: @unchecked) match { //@unchecked告诉编译器不用check这个match的case
    case Number(_) =&gt; "a number"
    case Var(_) =&gt; "a variable"
}</pre>
<p> </p>
<h2>5 Actors and Concurrency</h2>
<p>在处理并发上, Scala采取了和Clojure完全不同的思路, 采取actor模式尽量避免并发冲突的可能性, 用于补充Java传统的并发模式</p>
<h3>Actors and message passing</h3>
<p>Actor模式就不解释了, 这里actor就是一个线程 <br />
下面定义的echoActor, 会不停的读inbox, 并打印出收到的message</p>
<pre>val echoActor = actor {
    while (true) {
        receive {
            case msg =&gt;
                println("received message: "+ msg)
        }
    }
}</pre>
<p>然后, 如何给actor发消息? 很简单, 如下</p>
<pre>scala&gt; echoActor ! "hi there"
received message: hi there  //echoActor线程收到message, 并打印出来</pre>
<p>并且这里receive只会接收匹配的message(即匹配receive中的case的), 对于不匹配的message不会去处理</p>
<p> </p>
<h3>将普通线程当作actor</h3>
<p>在scala中也可以将native线程当作actor来用, 并且通过Actor.self来当前线程当作actor看</p>
<pre>import scala.actors.Actor._
scala&gt; self ! "hello"   //给当前线程actor发送消息
scala&gt; self.receive { case x =&gt; x }  //当前线程receive
res6: Any = hello</pre>
<p>这里需要先发message, 再recieve, 因为receive是block函数, 没有message不会返回 <br />
当然也可以使用receiveWithin, 来设置timeout</p>
<pre>scala&gt; self.receiveWithin(1000) { case x =&gt; x } // wait a sec!
res7: Any = TIMEOUT</pre>
<p> </p>
<h3>高效的react方法</h3>
<p>actor模式问题是, 每个actor都需要一个线程, 所以如果需要定义大量的actor效率会比较低 <br />
JVM只能创建几千个线程, 并且线程间的切换也是比较低效的</p>
<p>所以使用react方法可以共享线程以提高效率... <br />
原理在于, Scala actor模块会维护一个线程池, 用于分配线程给每个线程 <br />
对于receive方法, 分配的线程会一直被actor占住, 因为receive会返回值需要保持当前的调用栈 <br />
而react方法, 不会返回, 不需要保持调用栈, 所以执行完这个线程就可以被释放, 用于其他的actor</p>
<pre>object NameResolver extends Actor {
    import java.net.{InetAddress, UnknownHostException}
    def act() {
        react {
            case (name: String, actor: Actor) =&gt;
                actor ! getIp(name)
                act()
            case "EXIT" =&gt;
                println("Name resolver exiting.")// quit
            case msg =&gt;
                println("Unhandled message: "+ msg)
                act()
        }
    }
    def getIp(name: String): Option[InetAddress] = {
        try {
            Some(InetAddress.getByName(name))
        } catch {
            case _:UnknownHostException =&gt; None
        }
    }
}</pre>

<blockquote><p><strong>How react works <br /></strong>A return type of Nothing indicates a function will never return normally, but instead will always complete abruptly with an exception. And indeed, this is true of react. <br /><u><em>react的返回值是Nothing, 意思是不会正常返回, 即以异常作为react的结束 <br /></em></u>The actual implementation of react is not as simple as the following description, and subject to change, but conceptually you can think of react as working like this: <br />
When you call start on an actor, the start method will in some way arrange things such that some thread will eventually call act on that actor. If that act method invokes react, the react method will look in the actor’s mailbox for a message the passed partial function can handle. (It does this the same way as receive, by passing candidate messages to the partial function’s isDefinedAt method.) <br /><u><em>前面都是和receive一样的, 线程调用act, act调用react从actor的mailbox里面check是否有需要处理的message <br /></em></u>If it finds a message that can be handled, react will schedule the handling of that message for later execution and throw an exception. <br />
If it doesn’t find one, it will place the actor in “cold storage,” to be resurrected if and when it gets more messages in its mailbox, and throw an exception. <br />
In either case, react will complete abruptly with this exception, and so will act. The thread that invoked act will catch the exception, forget about the actor, and move on to other duties. <br /><em><u>如果找到需要处理的message, react就会处理这条message, 最终抛出exception, 如果找不到合适的message, 会将这个actor暂时休眠, 并抛出exception <br />
可以看到, 这里的关键在于, react一定会以exception结束, 最终调用act的线程会catch到这个exception, 知道react已经完成, 于是接着处理其他的事情, 所以达到线程重用 <br /></u></em>This is why if you want react to handle more than the first message, you’ll need to call act again from inside your partial function, or use some other means to get react invoked again.</p></blockquote>
<p>使用Actor.Loop来反复执行消息处理, 而不能用while</p>
<pre>def act() {
    loop {
        react {
            case (name: String, actor: Actor) =&gt;
                actor ! getIp(name)
            case msg =&gt;
                println("Unhandled message: " + msg)
        }
    }
}</pre>
<p> </p>
<h3>Actors should not block</h3>
<p>主Actor不应被阻塞, 因为这样他就不能及时的响应其他消息 <br />
处理的方法, 就是阻塞逻辑放到一个新的actor里面执行, 因为这个actor不会接收其他消息, 所以被阻塞是没有影响的</p>
<pre>val sillyActor2 = actor {
    def emoteLater() {
        val mainActor = self
        actor {   //使用新的actor
            Thread.sleep(1000)  //阻塞逻辑
            mainActor ! "Emote"    //将结果返回给主actor
        }
    }
    var emoted = 0
    emoteLater()

    loop {
        react {
            case "Emote" =&gt;
                println("I'm acting!")
                emoted += 1
                if (emoted &lt; 5)
                    emoteLater() //这里没有直接执行阻塞逻辑, 而是调用新的actor来执行
             case msg =&gt;
                println("Received: "+ msg)
        }
    }
}</pre>
<p>实际运行结果, 可见发送给sillyActor2的消息立即会得到处理, 不会被阻塞</p>
<pre>scala&gt; sillyActor2 ! "hi there"
scala&gt; Received: hi there
I'm acting!
I'm acting!
I'm acting!</pre>

<h3>Make messages self-contained</h3>
<p>通过case class来定义消息格式 <br />
否则如果只是简单的, lookerUpper ! ("www.scalalang.org", self), 其他人很难理解你的消息</p>
<pre>import scala.actors.Actor._
import java.net.{InetAddress, UnknownHostException}
case class LookupIP(name: String, respondTo: Actor) //通过case class来定义消息格式, 来便于理解
case class LookupResult(
    name: String,
    address: Option[InetAddress]
)
object NameResolver2 extends Actor {
    def act() {
        loop {
            react {
                case LookupIP(name, actor) =&gt;
                    actor ! LookupResult(name, getIp(name))
            }
        }
    }
    def getIp(name: String): Option[InetAddress] = {
    // As before (in Listing 30.3)
    }
}</pre>
<p>本文章摘自博客园，原文发布日期： 2013-09-25</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 05:31:36</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/list/" title="list">list</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/react/" title="react">react</a>, <a href="https://www.iamivan.net/tag/scala/" title="scala">scala</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Scala 常用语法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1MvvmNM.html" rel="bookmark">快速掌握ASP连接11种数据库的常用语法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文主要介绍了ASP连接11种数据库的常用语法,详细内容请参考下文: 1.Access数据库的DSN-less连接方法: 以下为引用的内容:set adocon=Server.Createobject(&quot;adodb.connection&quot;)adoconn.Open&quot;Driver={Microsoft Access Driver(*.mdb)};DBQ=&quot;&amp; _Server.MapPath(&quot;数据库所在路径&quot;) 2.Access OLE D			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMg7w8M.html" rel="bookmark">走近VB&period;Net（八） 常用语法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				语法 走近VB.Net(八) 常用语法一:Try---Catch---finally---end try 捕获错误 把一个可能出错的语句放在try后面,如果出错,执行catch语句, catch可以有多个,第一个catch不能捕获的错误,将被下一个catch语句所捕获.在所有的处理结束后,执行finally语句. 在一个try---end try 过程中可以使用catch与finally两个中的一个,或者两个一起用, 二:Protected, private, Public 封装控制 这三个关键			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWw9GXM.html" rel="bookmark">收集了python常用语法技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				收集了python常用语法技巧 1 获取本地mac地址:    import uuid    mac = uuid.uuid1().hex[-12:] 2 del 的使用    a = ['b','c','d']    del a[0]    则a = ['c','d']    del a[0:1]    则a = ['d']    del a    则a未定义 3 a = ['c',''d]    a.reverse()    a = ['d','c']    b = ','.join(a)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7YXjRM.html" rel="bookmark">Scala基本语法和概念</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文主要包括Scala的安装过程并理解Scala的基本语法和概念,包括表达式.变量.基本类型.函数.流程控制等相关内容. 1. 安装 从All Versions Scala下载所需版本Scala安装包,解压到指定目录之后,配置环境变量并使其生效. 如果你使用Mac,则可以使用brew安装: ⇒ brew install scala 在终端键入scala查看Scala的版本,并进入Scala的解释器: ⇒ scala Welcome to Scala version 2.11.6 (Java Ho			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE4aN6z.html" rel="bookmark">Vue1&period;0常用语法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				var vm = new Vue({ el: &quot;选择器&quot;, 挂载到页面的那个元素里,即确定vue的作用范围 外部可通过vm.$el访问,得到的是一个原生dom元素,可进行对应操作 a: '', //自定义属性 外部可通过vm.$options访问 data: { }, //实例属性都在这里面,外部通过实例名,即vm.$data调用 computed: { }, //计算属性,也是实例属性,只是以方法的形式存在,并可以有逻辑运算的属性 method: { }, //实例方法都在这里 wa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mx0nPjM.html" rel="bookmark">ARM-linux汇编常用语法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ARM linux常用汇编语法 ============================= 汇编语言每行的语法: lable: instruction ; comment 段操作: .section 格式: .section 段名 [标志］ ［标志］可以是如下: a 允许段 w 可写段 x 可执行段 常见段名: data, bss, text, rodata段,我们也可以定义我们自己的段. .data: 已初始化数据段 .bss: 未初始化数据段 .text:代码段 .rodata:只读段 汇编			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boL3m3M.html" rel="bookmark">jquery 注意事项与常用语法小结&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.关于选择器中含有特殊符号 选择器中含有&quot;.&quot;,&quot;#&quot;,&quot;(&quot;,&quot;]&quot;等特殊字符,根据W3C的规定,属性值中是不能含有这些特殊字符的,例如: 复制代码 代码如下: &lt;div id=&quot;id#b&quot;&gt;bb&lt;/div&gt; &lt;div id=&quot;id[1]&quot;&gt;&lt;/div&gt; 如果按照普通的方式来获取,例如: 复制代码 代码如下: $(&quot;#id#b			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNv207M.html" rel="bookmark">JSP经典学习笔记&lpar;包含各种入门常用语法&rpar;&lowbar;JSP编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文介绍了JSP经典学习笔记.分享给大家供大家参考.具体如下: JSP是Servlet的一种特殊形式,每个JSP页面就是一个Servlet实例--JSP页面有系统编译成Servlet,Servlet再负责响应用户请求. 1.JSP注释 &lt;%--注释内容--%&gt; ,与HTML注释&lt;!--注释内容--&gt;不同的是,编译后的HTML页面无法查看到JSP注释内容. 2.JSP声明 JSP声明用于声明变量和方法.JSP声明将会转换成Servlet中的成员变量或成员方法,因此,JSP声明依然符合			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zGWv3z.html" rel="bookmark">总结知识：FLASH常用语法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				语法 FLASH按钮+链接on (release) {getURL(&quot;相应链接&quot;);} 用flash 做那种弹出的小窗口, 分两步: 1.给flash中的按钮加入如下action: on (release) { getURL (&quot;&quot;); } ------------------------------------------------------------------------------------------2.在HTML页面的&lt;head&gt;..			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYBqxp.html" rel="bookmark" class="title">使用JavaScript和Ajax发出异步请求</a>
					<div>
						ajax|javascript|请求|异步 多数 Web 应用程序都使用请求/响应模型从服务器上获得完整的 HTML 页面.常常是点击一个按钮,等待服务器响应,再点击另一个按钮,然后再等待,这样一个反 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz78QAb.html" rel="bookmark" class="title">ReadAll 方法</a>
					<div>
						  读取 TextStream 文件的全部内容并返回由此得到的字符串. object.ReadAll( ); object 总是 TextStream 对象的名称. 说明 对大文件而言,使用 Read ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM16J9p.html" rel="bookmark" class="title">我在Spring中解决中文乱码的方法</a>
					<div>
						解决|中文|中文乱码 软件环境:JDK1.4.2_09+Eclipse3.1+MS SQL SERVER200+SP3+JTDS1.0.2+Struts1.1+Hibernate3.0.5+Sprin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKKQLb.html" rel="bookmark" class="title">源码学习&colon;一个简单的日历控件&lpar;6&rpar;</a>
					<div>
						控件|日历    if(defaultDate==undefined || defaultDate==&quot;&quot;){    var theDate=new Array();    cal ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzwjjdp.html" rel="bookmark" class="title">POWERDESIGNER 10&period;0 简介</a>
					<div>
						   POWERDESIGNER 10.0 简介  PowerDesigner 是唯一结合了下列几种标准建模技术的建模工具套件:使用 UML 的应用程序建模.业务流程建模和传统数据库建模技术,从而为您 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4m4qb.html" rel="bookmark" class="title">CSS-之外围容器自适应高度</a>
					<div>
						css|自适应  今天我在给客户制作网页(设计是采用xhtml+css)的时候遇到了这个问题,就是给外围容器左右加border,在IE下可以正常显示,FF下有的页面正常,有的就没有,产生的原因是不能自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz70xXb.html" rel="bookmark" class="title">换个角度看革命 对创业的若干启发</a>
					<div>
						我的挚友袁君,在大学里教授&quot;毛泽东MZD思想&quot;.我们无话不谈,无话不欢,只是一旦谈起MAO来,我们的冲突就很激烈,立即鸡同鸭讲地争论起来,彼此谁也说服不了谁. 后来,他为了教育我, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2KakM.html" rel="bookmark" class="title">在ASP&period;NET中获取文件属性</a>
					<div>
						asp.net 在ASP.NET中获取文件属性(Retrieving File Information In ASP.NET)By Steven Smith 使用ASP.NET我们可以很容易的得到文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1R9Dxp.html" rel="bookmark" class="title">C&plus;&plus;中string和string&period;h的作用和区别</a>
					<div>
						#include &lt; string .h &gt; void main() { string aaa = &quot; abcsd d &quot; ; printf( &quot; looki ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNE5vob.html" rel="bookmark" class="title">一名普通程序员的自我诊断书</a>
					<div>
						病症表现 感觉生活每天忙忙碌碌,碌碌无为,时间一天天重复,物价一天天飞涨,自己只能艰难靠自己的工资生活,每当夜晚来临的时候,晚上睡觉前的时候,总感觉生活总是少了些什么,惊慌和忧虑困扰着自己. 病人情况 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrG5Jp.html" rel="bookmark" class="title">用PS打造精美宝宝插画效果</a>
					<div>
						如何把活泼可爱宝宝照片打造成精美插画效果,本教程尽量用一些可爱的卡通元素如彩虹,花朵,蝴蝶,翅膀等.创意部分需要自己慢慢去发挥. 最终效果 1.打开下图所示的背景素材,执行:滤镜 &gt; 模糊 &g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwl0akb.html" rel="bookmark" class="title">shell 服务状态监控</a>
					<div>
						#!/bin/sh DBSTAT=`ps -ef|grep 'postmaster'|grep -v 'grep'` if [ &quot;$DBSTAT&quot; == &quot;&quot;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jy43b.html" rel="bookmark" class="title">PPT如何更加有效地组织菜单</a>
					<div>
						  怎么更有效地把这些幻灯片组织起来呢?菜单无疑是个比较好的方法. 点击&quot;播放器&quot;按钮,在弹出的窗口的&quot;功能&quot;选项卡下设置好所要显示的播放选项卡.标题.徽标等. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDArVlb.html" rel="bookmark" class="title">Windows Media Player如何优化音乐品质</a>
					<div>
						  激活自带的特效功能 很多人为了提高音乐的音效,可以说是绞尽脑汁想尽办法.可是他们往往不知道的是,其实很多软件就自带有相关的功能,用户只需要激活这些功能就可以体验到不一样的感觉.比如Windows系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWl4yb.html" rel="bookmark" class="title">Photoshop快速把人物图片转为精细的铅笔素描</a>
					<div>
						  经过前期很多人的努力,转素描的方法有了比较大的改进,现在的效果可以说非常逼真了.作者在这里介绍了几个不错的细节处理方法:用混合选项来控制反白过多的情况,用蒙版配合滤镜给素描增加纹理等. 原图 最终 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq85xab.html" rel="bookmark" class="title">Mac平台Neooffice 电子表格实现数据转置功能</a>
					<div>
						  最近因为工作上的原因,需要将电子表格中大量横排数据转换成竖排,在Microsoft Office 的 Excel 中有选择性粘贴──转置的功能可以实现这个效果,但我电脑上没有装MS Office, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo74yDb.html" rel="bookmark" class="title">让U盘拒绝病毒的最快方法</a>
					<div>
						  U盘的发明及流行明显方便了我们的日常工作和生活,但是有很多问题也随之而来.其中我想最困扰U盘用户的就是中毒问题了,不仅让你的U盘无法正常使用,而且更有U盘内资料被盗之虞.可见,拥有一个永远不中病毒 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWeB0b.html" rel="bookmark" class="title">蓝桥杯 c c&plus;&plus; 编程-请大神指导，不懂哪里错了</a>
					<div>
						问题描述 请大神指导,不懂哪里错了 这是杨辉三角,蓝桥杯的试题,试了几组数据都是对的,可是提交上去却是零分,不懂哪里错了,求指导,谢谢 解决方案 题目是这个,照片不清楚,拜托了! 问题描述 杨辉三角形 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EK3RM.html" rel="bookmark" class="title">如何在Linux命令行中创建以及展示演示稿</a>
					<div>
						如何在Linux命令行中创建以及展示演示稿 你在准备一场演讲的时候,脑海可能会先被图文并茂.形象华丽的演示图稿所占据.诚然,没有人会否认一份生动形象的演讲稿所带来的积极作用.然而,并非所有的演讲都需要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJ7yOp.html" rel="bookmark" class="title">存储过程-日期递增插入日期范围内的假数据（哥自己原创写了2小时）</a>
					<div>
						DELIMITER $$ DROP PROCEDURE IF EXISTS bp$$ CREATE PROCEDURE bp(i DATE,j DATE,k varchar(32)) BEGIN WH ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGJyab.html" rel="bookmark" class="title">kinect一代安装时，设备无法被识别，显示为未知设备 ，LED灯不亮，试过多版本SDK</a>
					<div>
						问题描述 kinect一代安装时,设备无法被识别,显示为未知设备 ,LED灯不亮,试过多版本SDK 手动安装C:Program FilesMicrosoft Kinect DriversDrivers ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwADjp.html" rel="bookmark" class="title">C&num;如何支持导出Windows标准32位动态链接库</a>
					<div>
						问题描述 有谁知道RGiesecke.DllExport到底是什么东西?怎么用的,到底是什么原理啊?不是说原生不支持导出的吗?在加了一个第三方库之后[DllExport()]到底干了什么?[/code ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjkArp.html" rel="bookmark" class="title">郭神，怎么样在android上阅读ppt文件</a>
					<div>
						问题描述 郭神,怎么样在android上阅读ppt文件 能给个思路吗?我找了poi,但poi转图片调用的api只能在电脑上用,手机上用不了. Android有自己处理图象的类.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kLANM.html" rel="bookmark" class="title">图像处理-图形处理Kinect sdk1&period;8   vs2012  opencv3</a>
					<div>
						问题描述 图形处理Kinect sdk1.8 vs2012 opencv3 在CSDN上抄的一个代码用来提取Kinect获得的颜色数据并用OpenCV显示,运行时总是出现以下错误: &quot;Sta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PlXrp.html" rel="bookmark" class="title">file-solaris 内存溢出问题</a>
					<div>
						问题描述 solaris 内存溢出问题 编译器版本Reading specs from /usr/sfw/lib/gcc/sparc-sun-solaris2.10/3.4.3/specsConfig ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Nx37z.html" rel="bookmark" class="title">谁说业绩导向的绩效管理穷途末路</a>
					<div>
						谁说业绩导向的绩效管理穷途末路? ■ 述/聂子龙 文/邱丘 围绕富士康员工连连跳楼事件和很多企业 的管理者 对话,笔者深切感受到不少HR管理者的视野和思维,早已不再局限于英美等国的模式和理念,而是发生 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEq9Xz.html" rel="bookmark" class="title">如何使用非模式窗口打开外部程序</a>
					<div>
						问题描述 如何使用非模式窗口打开外部程序 WPF调用外部键盘程序时焦点失去,现在想让键盘程序以非模式窗口打开,焦点继续存在 解决方案 参考:http://blog.csdn.net/xiaoyaofr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqwaLz.html" rel="bookmark" class="title">ubuntu14&period;10能支持xen到多少版本，ubuntu12&period;04呢？</a>
					<div>
						问题描述 ubuntu14.10能支持xen到多少版本,ubuntu12.04呢? 我现在要在ubuntu测试安装xen从高到低的各个版本,请问这些版本对ubuntu 的版本有什么要求,如题. 解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1GX9z.html" rel="bookmark" class="title">用poi导出word（2003版）图片导不出来的问题</a>
					<div>
						问题描述 用poi导出word(2003版)图片导不出来的问题 如题: 现想将一个个人简历导出doc格式的word文档,但是简历中的照片一直导不出,执行导出的是PoiHwpfExtractConten ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwErAM.html" rel="bookmark" class="title">普通main方法的java项目使用spring的context&colon;component-scan时导出jar时出的问题</a>
					<div>
						问题描述 是这样的,在eclipse中运行运行main方法,然后加载spring的配置文件,用组件扫描的方式进行配置的,一切都ok,没有任何问题,但是在讲这个项目导出问可执行的jar市,就出问题了&l ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.103 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
